package no.ntnu.idatt1002.demo.data.Budget;

import no.ntnu.idatt1002.demo.data.Economics.*;

import java.io.*;

/**
 * FileHandling is a class for writing and reading
 * Budgets to and from a file.
 *
 * @author andreas
 */

//Få fikset ny return knapp i dualList
    //Disable next i dualList før income har blitt lagt til. Kanksje filter som prevneter negativ max amount
    //La next button save dataene i to nye filer for persisterign i tilfelle "back" trykkes i newBudgetbudgetr
    //Gjøre user.dir path static + Fikse nye klasser for filehandling
    //Fikse vindu for old budget + FIKSE TRY CATCHES I ALLE METODENE!!!!!!!!!!
    //add menuitems i income og expense slik at
    //Gjøre slik at når du completer et budget (next button i budget window)
    //skal dette legges til i budgetreigsteret


    //System.out.println(System.getProperty("user.dir") + path); =
    //C:\Users\xulr0\IdeaProjects\skoleProsjekter\idatt1002\idatt1002_2023_9src/main/resources/

    //(System.getProperty("user.dir") + "/" + path) =
    //(path) =
    //(src/main/resources)
public class FileHandlingBudget {
    private static final String filePath = "src/main/resources/Budget"; //TODO CHANGE BACK to /resources/Budget/
    private static final String fileType = ".budget";

    private static final String path = "src/main/resources/";
    private static final String type = ".register";
    private static final String maxAmount = "maxAmount=";
    private static final String budgetAmount = "budgetAmount=";
    private static final String budgetCategory = "budgetCategory=";
    private static final String budgetDescription = "budgetDescription=";
    public static String id = "";

    /**
     * Method for writing (adding) a budget to a file.
     *
     * @param generalBudget the budget you want to write to a file.
     * @param fileTitle the name of the file you want to check
     * @throws IOException if an input or output exception occurred.
     */
    public static void writeGeneralBudgetToFile(String fileTitle, GeneralBudget generalBudget) throws IOException {
        try (BufferedWriter bw = new BufferedWriter(new FileWriter(path + readCurrentFile() + "/" + fileTitle + fileType))) {
        //try (BufferedWriter bw = new BufferedWriter(new FileWriter(filePath + fileTitle + fileType))) {
            bw.write(generalBudget.toString());
        } catch (IOException ex) {
            throw new IOException("Error writing to file: " + fileTitle);
        }
    }

    /**
     * Method for checking if a .budget file is empty.
     *
     * @param fileTitle the name of the file you want to check
     * @return true or false depending on if file is empty.
     * @throws IOException if an input or output exception occurred.
     */
    public static boolean isEmpty(String fileTitle) throws IOException {
        /*try (BufferedReader br = new BufferedReader(new FileReader(filePath + fileTitle + fileType))) {
            return br.readLine() == null;
        }*/
        BufferedReader br = new BufferedReader(new FileReader(path + readCurrentFile() + "/" + fileTitle + fileType));
        System.out.println("Trying budget isEmpty in: " + path + readCurrentFile() + "/" + fileTitle + fileType);
        return br.readLine() == null;
    }


    /**
     * Method for checking if a .budget file is new (no categories)
     * or old (has budget categories)
     * @param fileTitle The name of the file
     * @return True, if the budget is new. Else, returns false
     * @throws IOException
     */
    public static boolean isNewBudget(String fileTitle) throws IOException {
        try (BufferedReader br = new BufferedReader(
            new FileReader(path + readCurrentFile() + "/" + fileTitle + fileType))) {
            //new FileReader(filePath + fileTitle + fileType))) {

            for (int i = 0; i < 2; ++i) {
                br.readLine();
            }

            if (br.readLine() == null) {
                System.out.println("Is new budget - no max amount");
                return true;
            }
        }
        System.out.println("Is 'old' budget - has max amount");
        return false;
    }

    public static void writeBudgetRegisterToArchive(BudgetRegister budgetNames) throws IOException {
        try {
            BufferedWriter bw = new BufferedWriter(new FileWriter(System.getProperty("user.dir") + "/" + path + "Archive.txt"));
            System.out.println(System.getProperty("user.dir") + "/" + path + "Archive.txt");
            bw.write("motherfucer");
        } catch (IOException ioe) {
            ioe.printStackTrace();
            throw new IOException("Could not write to file: Archive.txt");
        }
    }

    public static BudgetRegister readBudgetArchive(String fileTitle) throws IOException {
        BufferedReader br;
        BudgetRegister budgetRegister = null;
        String budgetName;

        try {
            br = new BufferedReader(
                new FileReader(System.getProperty("user.dir") + "/" + path
                    + "Archive.txt"));
        } catch (IOException ioe) {
            throw new IOException("File does not exist", ioe);
        }

        String line;
        String nextLine = br.readLine();
        while ((line = nextLine) != null) {
            System.out.println(line);
            nextLine = br.readLine();
            budgetName = line;

            if(budgetRegister == null){
                budgetRegister = new BudgetRegister();
            }
            budgetRegister.addBudgetName(budgetName);
        }
        return budgetRegister;
    }
    public static boolean isCurrentFileEmpty(String fileTitle) throws IOException {
        try (BufferedReader br = new BufferedReader(new FileReader(System.getProperty("user.dir") + "src/main/resources/"
            + "CurrentFile.txt"))) {
            return br.readLine() == null;
        }
    }

    public static void writeSavingsToFile() {

    }
    public static void writeMaxAmountToFile(String fileDestination, String maxAmount) throws IOException {
        try (BufferedWriter bw = new BufferedWriter(new FileWriter(System.getProperty("user.dir") + "/src/main/resources/"
            + fileDestination + "/Budget.budget"))) {
            bw.write("maxAmount=" + maxAmount);
            System.out.println("Max amount is...");
        } catch (IOException ex) {
            throw new IOException("Error writing to file: " + fileDestination);
        }
    }

    public static String readCurrentFile() throws IOException {
        BufferedReader br;
        try {
            System.out.print("Reading current file...");
            FileReader fileReader = new FileReader(System.getProperty("user.dir") + "/src/main/resources/CurrentFile.txt");
            br = new BufferedReader(fileReader);
        } catch (IOException ioException) {
            throw new IOException("File: CurrentFile.txt does not exist");
        }
        System.out.println("Successful read on current file");
        return br.readLine();
    }

    public static void updateCurrentFile(String budgetName) throws IOException {
        try (BufferedWriter bw = new BufferedWriter(new FileWriter(System.getProperty("user.dir") + "/src/main/resources/CurrentFile.txt"))) {
            bw.write(budgetName);
            System.out.println("Current file is: " + budgetName);
        } catch (IOException ex) {
            throw new IOException("Error writing to file: " + "CurrentFile.txt");
        }
    }

    public static boolean deleteBudgetDirectory(String budgetID) {
        File targetDirectory = new File(System.getProperty("user.dir") + "/src/main/resources/" + budgetID);
        System.out.println("Deleting directory:" + targetDirectory.getPath());

        String[]entries = targetDirectory.list();
        assert entries != null;
        for(String file : entries){
            File currentFile = new File(targetDirectory.getPath(),file);
            System.out.println("Deleting file:" + currentFile.delete());
        }

        return targetDirectory.delete();
    }
    public static boolean createBudgetDirectory(String budgetID) {
        System.out.println("Directory: " + System.getProperty("user.dir") + "/src/main/resources/" + budgetID);
        File f = new File(System.getProperty("user.dir") + "/src/main/resources/" + budgetID);
        return f.mkdir();
    }
    public static void createNewIncomeFile(String budgetID, String incomeFileTitle) throws IOException {
        System.out.println("Income filepath: " + System.getProperty("user.dir") + "/src/main/resources/" + budgetID + "/" + incomeFileTitle + type);
        File incomeFile = new File(System.getProperty("user.dir") + "/src/main/resources/" + budgetID + "/" + incomeFileTitle + type);
        incomeFile.createNewFile();
    }

    public static void createNewExpenseFile(String budgetID, String expenseFileTitle) throws IOException {
        System.out.println("Expense filePath: " + System.getProperty("user.dir") + "/src/main/resources/" + budgetID + "/" + expenseFileTitle + type);
        File expenseFile = new File(System.getProperty("user.dir") + "/src/main/resources/" + budgetID + "/" + expenseFileTitle + type);
        expenseFile.createNewFile();
    }

    public static void createNewBudgetFile(String budgetID, String budgetFileTitle) throws IOException {
        System.out.println("Budget filePath: " + System.getProperty("user.dir") + "/src/main/resources/" + budgetID + "/" + budgetFileTitle + fileType);
        File budgetFile = new File(System.getProperty("user.dir") + "/src/main/resources/" + budgetID + "/" + budgetFileTitle + fileType);
        budgetFile.createNewFile();
    }

    /**
     * Method for reading (getting) a Budget from a file.
     *
     * @param fileTitle the name of the file you want to read from.
     * @return the GeneralBudget from the file.
     * @throws IOException if an input or output exception occurred.
     */
    public static GeneralBudget readGeneralBudgetFromFile(String fileTitle) throws IOException {
        GeneralBudget generalBudget = null;
        double maxAmount = 0;
        double budgetAmount = 0;
        ExpenseCategory expenseCategory = null;
        String budgetDescription = null;

        try (BufferedReader br = new BufferedReader(new FileReader( System.getProperty("user.dir") + "/" + path + readCurrentFile() + "/" + fileTitle + fileType))) {
            String line;
            String nextLine = br.readLine();
            while ((line = nextLine) != null) {
                nextLine = br.readLine();
                if (line.startsWith(FileHandlingBudget.maxAmount)) {
                    maxAmount = Double.parseDouble(line.replace(FileHandlingBudget.maxAmount,""));
                } else if (line.startsWith(FileHandlingBudget.budgetAmount)) {
                    budgetAmount = Double.parseDouble(line.replace(FileHandlingBudget.budgetAmount,""));
                } else if (line.startsWith(FileHandlingBudget.budgetCategory)) {
                    line = line.replace(FileHandlingBudget.budgetCategory, "");
                    expenseCategory = switch (line) {
                        case "FOOD" -> ExpenseCategory.FOOD;
                        case "CLOTHES" -> ExpenseCategory.CLOTHES;
                        case "BOOKS" -> ExpenseCategory.BOOKS;
                        default -> ExpenseCategory.OTHER;
                    };
                } else if (line.startsWith(FileHandlingBudget.budgetDescription)) {
                    budgetDescription = line.replace(FileHandlingBudget.budgetDescription,"");
                }
                if (line.isEmpty() || (nextLine == null)) {
                    if(generalBudget == null){
                        generalBudget = new GeneralBudget(maxAmount);
                    } else{
                        generalBudget.addToBudget(budgetAmount,budgetDescription,expenseCategory);
                    }
                }
            }
        }
        return generalBudget;
    }
}
